var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { StyleSheet, View } from 'react-native';
import { useStack } from '../hooks';
import { preparePaddings } from '../helpers/preparePaddings';
export var Stack = function (_a) {
    var children = _a.children, spacing = _a.spacing, padding = _a.padding, style = _a.style, props = __rest(_a, ["children", "spacing", "padding", "style"]);
    var globalConfig = useStack();
    var options = Object.assign(globalConfig, { spacing: spacing, padding: padding });
    var renderDivider = function () {
        // if (typeof options.spacing !== 'number') {
        //   return options.spacing
        // }
        return (React.createElement(View, { style: StyleSheet.flatten([
                {
                    width: options.spacing,
                    height: options.spacing,
                },
                options.debug && { backgroundColor: '#f0f' },
            ]) }));
    };
    var renderStack = function () {
        var elements = Array.isArray(children) ? children : [children];
        elements = elements.filter(function (child) {
            return Array.isArray(child) || React.isValidElement(child);
        });
        return elements.reduce(function (children, child, index) {
            // if (children?.length === 0) {
            //   return [child]
            // }
            var addSpaces = function () {
                if (renderDivider) {
                    return React.cloneElement(renderDivider(), {
                        key: "stack-divider-" + index,
                    });
                }
                return [];
            };
            return [children, addSpaces(), child];
        }, []);
    };
    return (React.createElement(View, __assign({}, props, { style: StyleSheet.flatten([style, preparePaddings(options.padding || 0)]) }), renderStack()));
};
